<template>
    <div :class="classObj" class="app-wrapper">
        <div v-if="device==='mobile'&& sidebar.opened" class="drawer-bg" @click="handleClickOutside" />
        <Sidebar class="sidebar-container" />
        <div class="main-container">
            <Navbar/>
            <TagView/>
            <AppMain />
        </div>
    </div>
</template>

<script>
import { Sidebar, Navbar, TagView } from '@/components';
import { AppMain } from './components';

export default {
    name: 'Layout',
    components: {
        Sidebar,
        Navbar,
        TagView,
        AppMain
    },
    computed: {
        sidebar() {
            return this.$store.state.sidebar;
        },
        device() {
            return this.$store.state.device;
        },
        classObj() {
            return {
                hideSidebar: !this.sidebar.opened,
                openSidebar: this.sidebar.opened,
                withoutAnimation: this.sidebar.withoutAnimation,
                mobile: this.device === 'mobile'
            }
        }
    },
    methods: {
        handleClickOutside() {
            return this.$store.dispatch('closeSidebar', {withoutAnimation: false});
        }
    }
}
</script>

<style rel="stylesheet/scss" lang="scss" scoped>
    @import "~@/styles/mixin.scss";
    .app-wrapper {
        @include clearfix;
        position: relative;
        height: 100%;
        width: 100%;
        &.mobile.openSidebar{
            position: fixed;
            top: 0;
        }
    }
    .drawer-bg {
        background: #000;
        opacity: 0.3;
        width: 100%;
        top: 0;
        height: 100%;
        position: absolute;
        z-index: 999;
    }
</style>